---
title: Gyroscope
slug: Web/API/Gyroscope
tags:
  - API
  - Generic Sensor API
  - Gyroscope
  - Gyroscope API
  - Interface
  - Reference
  - Sensor
  - Sensor APIs
  - Sensors
---
<div>{{APIRef("Gyroscope")}}</div>

<p><span class="seoSummary">The <strong><code>Gyroscope</code></strong> interface of the <a href="/docs/Web/API/Sensor_APIs">Sensor APIs</a> provides on each reading the angular velocity of the device along all three axes. </span></p>

<p>To use this sensor, the user must grant permission to the <code>'gyroscope'</code> device sensor through the {{domxref('Permissions')}} API.</p>

<p>If a feature policy blocks use of a feature it is because your code is inconsistent with the policies set on your server. This is not something that would ever be shown to a user. See {{httpheader('Feature-Policy')}} for implementation instructions.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("Gyroscope.Gyroscope()")}}</dt>
 <dd>Creates a new <code>Gyroscope</code> object.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref('Gyroscope.x')}} {{readonlyinline}}</dt>
 <dd>Returns a double, containing the angular velocity of the device along the device's x axis.</dd>
 <dt>{{domxref('Gyroscope.y')}} {{readonlyinline}}</dt>
 <dd>Returns a double, containing the angular velocity of the device along the device's y axis.</dd>
 <dt>{{domxref('Gyroscope.z')}} {{readonlyinline}}</dt>
 <dd>Returns a double, containing the angular velocity of the device along the device's z axis.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>The gyroscope is typically read in the {{domxref('Sensor.onreading')}} event callback. In the example below this occurs sixty times a second.</p>

<pre class="brush: js">let gyroscope = new Gyroscope({frequency: 60});

gyroscope.addEventListener('reading', e =&gt; {
  console.log("Angular velocity along the X-axis " + gyroscope.x);
  console.log("Angular velocity along the Y-axis " + gyroscope.y);
  console.log("Angular velocity along the Z-axis " + gyroscope.z);
});
gyroscope.start();</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Generic Sensor')}}</td>
   <td>{{Spec2('Generic Sensor')}}</td>
   <td>Defines sensors in general.</td>
  </tr>
  <tr>
   <td>{{SpecName('Gyroscope','#gyroscope-interface','Gyroscope')}}</td>
   <td>{{Spec2('Gyroscope')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Gyroscope")}}</p>
